# Class ComboPooledDataSource

java.lang.Object
com.mchange.v2.c3p0.impl.AbstractIdentityTokenized
com.mchange.v2.c3p0.impl.IdentityTokenResolvable
com.mchange.v2.c3p0.impl.PoolBackedDataSourceBase
com.mchange.v2.c3p0.impl.AbstractPoolBackedDataSource
com.mchange.v2.c3p0.ComboPooledDataSource

All Implemented Interfaces:
  `com.mchange.v2.c3p0.impl.IdentityTokenized, PooledDataSource, Serializable, Wrapper, Referenceable, CommonDataSource, DataSource`

public final class ComboPooledDataSource extends com.mchange.v2.c3p0.impl.AbstractPoolBackedDataSource implements PooledDataSource, Serializable, Referenceable

For the meaning of most of these properties, please see c3p0's top-level documentation!

See Also:
  - Serialized Form

## Field Summary

### Fields inherited from class com.mchange.v2.c3p0.impl.PoolBackedDataSourceBase

`pcs, vcs`

## Constructor Summary

Constructors
Constructor
Description
`ComboPooledDataSource()`
`ComboPooledDataSource(boolean autoregister)`
`ComboPooledDataSource(String configName)`

## Method Summary

Modifier and Type
Method
Description
`int`
`getAcquireIncrement()`
`int`
`getAcquireRetryAttempts()`
`int`
`getAcquireRetryDelay()`
`String`
`getAutomaticTestTable()`
`int`
`getCheckoutTimeout()`
`String`
`getConnectionCustomizerClassName()`
`String`
`getConnectionTesterClassName()`
`String`
`getDescription()`
`String`
`getDriverClass()`
`String`
`getFactoryClassLocation()`
`int`
`getIdleConnectionTestPeriod()`
`int`
`getInitialPoolSize()`
`String`
`getJdbcUrl()`
`int`
`getMaxAdministrativeTaskTime()`
`int`
`getMaxConnectionAge()`
`int`
`getMaxIdleTime()`
`int`
`getMaxIdleTimeExcessConnections()`
`int`
`getMaxPoolSize()`
`int`
`getMaxStatements()`
`int`
`getMaxStatementsPerConnection()`
`int`
`getMinPoolSize()`
`String`
`getOverrideDefaultPassword()`
`String`
`getOverrideDefaultUser()`
`String`
`getPassword()`
`String`
`getPreferredTestQuery()`
`Properties`
`getProperties()`
`int`
`getPropertyCycle()`
`int`
`getUnreturnedConnectionTimeout()`
`String`
`getUser()`
`String`
`getUserOverridesAsString()`
`boolean`
`isAutoCommitOnClose()`
`boolean`
`isBreakAfterAcquireFailure()`
`boolean`
`isDebugUnreturnedConnectionStackTraces()`
`boolean`
`isForceIgnoreUnresolvedTransactions()`
`boolean`
`isTestConnectionOnCheckin()`
`boolean`
`isTestConnectionOnCheckout()`
`boolean`
`isUsesTraditionalReflectiveProxies()`
`void`
`setAcquireIncrement(int acquireIncrement)`
`void`
`setAcquireRetryAttempts(int acquireRetryAttempts)`
`void`
`setAcquireRetryDelay(int acquireRetryDelay)`
`void`
`setAutoCommitOnClose(boolean autoCommitOnClose)`
`void`
`setAutomaticTestTable(String automaticTestTable)`
`void`
`setBreakAfterAcquireFailure(boolean breakAfterAcquireFailure)`
`void`
`setCheckoutTimeout(int checkoutTimeout)`
`void`
`setConnectionCustomizerClassName(String connectionCustomizerClassName)`
`void`
`setConnectionTesterClassName(String connectionTesterClassName)`
`void`
`setDebugUnreturnedConnectionStackTraces(boolean debugUnreturnedConnectionStackTraces)`
`void`
`setDescription(String description)`
`void`
`setDriverClass(String driverClass)`
`void`
`setFactoryClassLocation(String factoryClassLocation)`
`void`
`setForceIgnoreUnresolvedTransactions(boolean forceIgnoreUnresolvedTransactions)`
`void`
`setIdleConnectionTestPeriod(int idleConnectionTestPeriod)`
`void`
`setInitialPoolSize(int initialPoolSize)`
`void`
`setJdbcUrl(String jdbcUrl)`
`void`
`setMaxAdministrativeTaskTime(int maxAdministrativeTaskTime)`
`void`
`setMaxConnectionAge(int maxConnectionAge)`
`void`
`setMaxIdleTime(int maxIdleTime)`
`void`
`setMaxIdleTimeExcessConnections(int maxIdleTimeExcessConnections)`
`void`
`setMaxPoolSize(int maxPoolSize)`
`void`
`setMaxStatements(int maxStatements)`
`void`
`setMaxStatementsPerConnection(int maxStatementsPerConnection)`
`void`
`setMinPoolSize(int minPoolSize)`
`void`
`setOverrideDefaultPassword(String overrideDefaultPassword)`
`void`
`setOverrideDefaultUser(String overrideDefaultUser)`
`void`
`setPassword(String password)`
`void`
`setPreferredTestQuery(String preferredTestQuery)`
`void`
`setProperties(Properties properties)`
`void`
`setPropertyCycle(int propertyCycle)`
`void`
`setTestConnectionOnCheckin(boolean testConnectionOnCheckin)`
`void`
`setTestConnectionOnCheckout(boolean testConnectionOnCheckout)`
`void`
`setUnreturnedConnectionTimeout(int unreturnedConnectionTimeout)`
`void`
`setUser(String user)`
`void`
`setUserOverridesAsString(String userOverridesAsString)`
`void`
`setUsesTraditionalReflectiveProxies(boolean usesTraditionalReflectiveProxies)`
`String`
`toString()`

### Methods inherited from class com.mchange.v2.c3p0.impl.AbstractPoolBackedDataSource

`close, close, getAllUsers, getConnection, getConnection, getDataSourceName, getEffectivePropertyCycle, getEffectivePropertyCycleDefaultUser, getLastAcquisitionFailure, getLastAcquisitionFailureDefaultUser, getLastCheckinFailure, getLastCheckinFailureDefaultUser, getLastCheckoutFailure, getLastCheckoutFailureDefaultUser, getLastConnectionTestFailure, getLastConnectionTestFailureDefaultUser, getLastIdleTestFailure, getLastIdleTestFailureDefaultUser, getLoginTimeout, getLogWriter, getNumBusyConnections, getNumBusyConnections, getNumBusyConnectionsAllUsers, getNumBusyConnectionsDefaultUser, getNumConnections, getNumConnections, getNumConnectionsAllUsers, getNumConnectionsDefaultUser, getNumFailedCheckins, getNumFailedCheckinsDefaultUser, getNumFailedCheckouts, getNumFailedCheckoutsDefaultUser, getNumFailedIdleTests, getNumFailedIdleTestsDefaultUser, getNumIdleConnections, getNumIdleConnections, getNumIdleConnectionsAllUsers, getNumIdleConnectionsDefaultUser, getNumThreadsAwaitingCheckout, getNumThreadsAwaitingCheckoutDefaultUser, getNumUnclosedOrphanedConnections, getNumUnclosedOrphanedConnections, getNumUnclosedOrphanedConnectionsAllUsers, getNumUnclosedOrphanedConnectionsDefaultUser, getNumUserPools, getParentLogger, getStartTimeMillis, getStartTimeMillisDefaultUser, getStatementCacheNumCheckedOut, getStatementCacheNumCheckedOutDefaultUser, getStatementCacheNumCheckedOutStatementsAllUsers, getStatementCacheNumConnectionsWithCachedStatements, getStatementCacheNumConnectionsWithCachedStatementsAllUsers, getStatementCacheNumConnectionsWithCachedStatementsDefaultUser, getStatementCacheNumStatements, getStatementCacheNumStatementsAllUsers, getStatementCacheNumStatementsDefaultUser, getThreadPoolNumActiveThreads, getThreadPoolNumIdleThreads, getThreadPoolNumTasksPending, getThreadPoolSize, getUpTimeMillis, getUpTimeMillisDefaultUser, hardReset, initializeNamedConfig, isWrapperFor, resetPoolManager, resetPoolManager, sampleLastAcquisitionFailureStackTrace, sampleLastAcquisitionFailureStackTraceDefaultUser, sampleLastCheckinFailureStackTrace, sampleLastCheckinFailureStackTraceDefaultUser, sampleLastCheckoutFailureStackTrace, sampleLastCheckoutFailureStackTraceDefaultUser, sampleLastConnectionTestFailureStackTrace, sampleLastConnectionTestFailureStackTraceDefaultUser, sampleLastIdleTestFailureStackTrace, sampleLastIdleTestFailureStackTraceDefaultUser, sampleStatementCacheStatus, sampleStatementCacheStatusDefaultUser, sampleThreadPoolStackTraces, sampleThreadPoolStatus, setLoginTimeout, setLogWriter, softReset, softResetAllUsers, softResetDefaultUser, unwrap`

### Methods inherited from class com.mchange.v2.c3p0.impl.PoolBackedDataSourceBase

`addPropertyChangeListener, addPropertyChangeListener, addVetoableChangeListener, extraToStringInfo, getConnectionPoolDataSource, getIdentityToken, getNumHelperThreads, getPropertyChangeSupport, getReference, getVetoableChangeSupport, removePropertyChangeListener, removePropertyChangeListener, removeVetoableChangeListener, setConnectionPoolDataSource, setDataSourceName, setIdentityToken, setNumHelperThreads`

### Methods inherited from class com.mchange.v2.c3p0.impl.IdentityTokenResolvable

`doResolve, readResolve, verifyResolve`

### Methods inherited from class com.mchange.v2.c3p0.impl.AbstractIdentityTokenized

`equals, hashCode`

### Methods inherited from class Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface CommonDataSource

`createShardingKeyBuilder, getParentLogger`

### Methods inherited from interface DataSource

`createConnectionBuilder, getConnection, getConnection, getLoginTimeout, getLogWriter, setLoginTimeout, setLogWriter`

### Methods inherited from interface PooledDataSource

`close, close, getAllUsers, getDataSourceName, getEffectivePropertyCycle, getEffectivePropertyCycleDefaultUser, getIdentityToken, getLastAcquisitionFailure, getLastAcquisitionFailureDefaultUser, getLastCheckinFailure, getLastCheckinFailureDefaultUser, getLastCheckoutFailure, getLastCheckoutFailureDefaultUser, getLastConnectionTestFailure, getLastConnectionTestFailureDefaultUser, getLastIdleTestFailure, getLastIdleTestFailureDefaultUser, getNumBusyConnections, getNumBusyConnections, getNumBusyConnectionsAllUsers, getNumBusyConnectionsDefaultUser, getNumConnections, getNumConnections, getNumConnectionsAllUsers, getNumConnectionsDefaultUser, getNumFailedCheckinsDefaultUser, getNumFailedCheckoutsDefaultUser, getNumFailedIdleTestsDefaultUser, getNumHelperThreads, getNumIdleConnections, getNumIdleConnections, getNumIdleConnectionsAllUsers, getNumIdleConnectionsDefaultUser, getNumThreadsAwaitingCheckout, getNumThreadsAwaitingCheckoutDefaultUser, getNumUnclosedOrphanedConnections, getNumUnclosedOrphanedConnections, getNumUnclosedOrphanedConnectionsAllUsers, getNumUnclosedOrphanedConnectionsDefaultUser, getNumUserPools, getStartTimeMillisDefaultUser, getStatementCacheNumCheckedOut, getStatementCacheNumCheckedOutDefaultUser, getStatementCacheNumCheckedOutStatementsAllUsers, getStatementCacheNumConnectionsWithCachedStatements, getStatementCacheNumConnectionsWithCachedStatementsAllUsers, getStatementCacheNumConnectionsWithCachedStatementsDefaultUser, getStatementCacheNumStatements, getStatementCacheNumStatementsAllUsers, getStatementCacheNumStatementsDefaultUser, getThreadPoolNumActiveThreads, getThreadPoolNumIdleThreads, getThreadPoolNumTasksPending, getThreadPoolSize, getUpTimeMillisDefaultUser, hardReset, sampleLastAcquisitionFailureStackTrace, sampleLastAcquisitionFailureStackTraceDefaultUser, sampleLastCheckinFailureStackTrace, sampleLastCheckinFailureStackTraceDefaultUser, sampleLastCheckoutFailureStackTrace, sampleLastCheckoutFailureStackTraceDefaultUser, sampleLastConnectionTestFailureStackTrace, sampleLastConnectionTestFailureStackTraceDefaultUser, sampleLastIdleTestFailureStackTrace, sampleLastIdleTestFailureStackTraceDefaultUser, sampleStatementCacheStatus, sampleStatementCacheStatusDefaultUser, sampleThreadPoolStackTraces, sampleThreadPoolStatus, setDataSourceName, softReset, softResetAllUsers, softResetDefaultUser`

### Methods inherited from interface Referenceable

`getReference`

### Methods inherited from interface Wrapper

`isWrapperFor, unwrap`

## Constructor Details

### ComboPooledDataSource

public ComboPooledDataSource()

### ComboPooledDataSource

public ComboPooledDataSource(boolean autoregister)

### ComboPooledDataSource

public ComboPooledDataSource(String configName)

## Method Details

### getDescription

public String getDescription()

### setDescription

public void setDescription(String description)

### getDriverClass

public String getDriverClass()

### setDriverClass

public void setDriverClass(String driverClass) throws PropertyVetoException

Throws:
  `PropertyVetoException`

### getJdbcUrl

public String getJdbcUrl()

### setJdbcUrl

public void setJdbcUrl(String jdbcUrl)

### getProperties

public Properties getProperties()

### setProperties

public void setProperties(Properties properties)

### getUser

public String getUser()

### setUser

public void setUser(String user)

### getPassword

public String getPassword()

### setPassword

public void setPassword(String password)

### getCheckoutTimeout

public int getCheckoutTimeout()

### setCheckoutTimeout

public void setCheckoutTimeout(int checkoutTimeout)

### getAcquireIncrement

public int getAcquireIncrement()

### setAcquireIncrement

public void setAcquireIncrement(int acquireIncrement)

### getAcquireRetryAttempts

public int getAcquireRetryAttempts()

### setAcquireRetryAttempts

public void setAcquireRetryAttempts(int acquireRetryAttempts)

### getAcquireRetryDelay

public int getAcquireRetryDelay()

### setAcquireRetryDelay

public void setAcquireRetryDelay(int acquireRetryDelay)

### isAutoCommitOnClose

public boolean isAutoCommitOnClose()

### setAutoCommitOnClose

public void setAutoCommitOnClose(boolean autoCommitOnClose)

### getConnectionTesterClassName

public String getConnectionTesterClassName()

### setConnectionTesterClassName

public void setConnectionTesterClassName(String connectionTesterClassName) throws PropertyVetoException

Throws:
  `PropertyVetoException`

### getAutomaticTestTable

public String getAutomaticTestTable()

### setAutomaticTestTable

public void setAutomaticTestTable(String automaticTestTable)

### isForceIgnoreUnresolvedTransactions

public boolean isForceIgnoreUnresolvedTransactions()

### setForceIgnoreUnresolvedTransactions

public void setForceIgnoreUnresolvedTransactions(boolean forceIgnoreUnresolvedTransactions)

### getIdleConnectionTestPeriod

public int getIdleConnectionTestPeriod()

### setIdleConnectionTestPeriod

public void setIdleConnectionTestPeriod(int idleConnectionTestPeriod)

### getInitialPoolSize

public int getInitialPoolSize()

### setInitialPoolSize

public void setInitialPoolSize(int initialPoolSize)

### getMaxIdleTime

public int getMaxIdleTime()

### setMaxIdleTime

public void setMaxIdleTime(int maxIdleTime)

### getMaxPoolSize

public int getMaxPoolSize()

### setMaxPoolSize

public void setMaxPoolSize(int maxPoolSize)

### getMaxStatements

public int getMaxStatements()

### setMaxStatements

public void setMaxStatements(int maxStatements)

### getMaxStatementsPerConnection

public int getMaxStatementsPerConnection()

### setMaxStatementsPerConnection

public void setMaxStatementsPerConnection(int maxStatementsPerConnection)

### getMinPoolSize

public int getMinPoolSize()

### setMinPoolSize

public void setMinPoolSize(int minPoolSize)

### getOverrideDefaultUser

public String getOverrideDefaultUser()

### setOverrideDefaultUser

public void setOverrideDefaultUser(String overrideDefaultUser)

### getOverrideDefaultPassword

public String getOverrideDefaultPassword()

### setOverrideDefaultPassword

public void setOverrideDefaultPassword(String overrideDefaultPassword)

### getPropertyCycle

public int getPropertyCycle()

### setPropertyCycle

public void setPropertyCycle(int propertyCycle)

### isBreakAfterAcquireFailure

public boolean isBreakAfterAcquireFailure()

### setBreakAfterAcquireFailure

public void setBreakAfterAcquireFailure(boolean breakAfterAcquireFailure)

### isTestConnectionOnCheckout

public boolean isTestConnectionOnCheckout()

### setTestConnectionOnCheckout

public void setTestConnectionOnCheckout(boolean testConnectionOnCheckout)

### isTestConnectionOnCheckin

public boolean isTestConnectionOnCheckin()

### setTestConnectionOnCheckin

public void setTestConnectionOnCheckin(boolean testConnectionOnCheckin)

### isUsesTraditionalReflectiveProxies

public boolean isUsesTraditionalReflectiveProxies()

### setUsesTraditionalReflectiveProxies

public void setUsesTraditionalReflectiveProxies(boolean usesTraditionalReflectiveProxies)

### getPreferredTestQuery

public String getPreferredTestQuery()

### setPreferredTestQuery

public void setPreferredTestQuery(String preferredTestQuery)

### getUserOverridesAsString

public String getUserOverridesAsString()

### setUserOverridesAsString

public void setUserOverridesAsString(String userOverridesAsString) throws PropertyVetoException

Throws:
  `PropertyVetoException`

### getMaxAdministrativeTaskTime

public int getMaxAdministrativeTaskTime()

### setMaxAdministrativeTaskTime

public void setMaxAdministrativeTaskTime(int maxAdministrativeTaskTime)

### getMaxIdleTimeExcessConnections

public int getMaxIdleTimeExcessConnections()

### setMaxIdleTimeExcessConnections

public void setMaxIdleTimeExcessConnections(int maxIdleTimeExcessConnections)

### getMaxConnectionAge

public int getMaxConnectionAge()

### setMaxConnectionAge

public void setMaxConnectionAge(int maxConnectionAge)

### getConnectionCustomizerClassName

public String getConnectionCustomizerClassName()

### setConnectionCustomizerClassName

public void setConnectionCustomizerClassName(String connectionCustomizerClassName)

### getUnreturnedConnectionTimeout

public int getUnreturnedConnectionTimeout()

### setUnreturnedConnectionTimeout

public void setUnreturnedConnectionTimeout(int unreturnedConnectionTimeout)

### isDebugUnreturnedConnectionStackTraces

public boolean isDebugUnreturnedConnectionStackTraces()

### setDebugUnreturnedConnectionStackTraces

public void setDebugUnreturnedConnectionStackTraces(boolean debugUnreturnedConnectionStackTraces)

### getFactoryClassLocation

public String getFactoryClassLocation()

Overrides:
  `getFactoryClassLocation` in class `com.mchange.v2.c3p0.impl.PoolBackedDataSourceBase`

### setFactoryClassLocation

public void setFactoryClassLocation(String factoryClassLocation)

Overrides:
  `setFactoryClassLocation` in class `com.mchange.v2.c3p0.impl.PoolBackedDataSourceBase`

### toString

public String toString()

Overrides:
  `toString` in class `com.mchange.v2.c3p0.impl.PoolBackedDataSourceBase`